
# [v3.1.1] - 2024-09-23 

## BACKEND

### Added

- app-updater: Add processManagerEndpoint argument for Api-Gateway and Dms-Broker (#50443).
- DMS: Add "offsetMinFromUTC" for historical data request (#50094).
- DMS: Add "showChilds" for get request (#50272).
- DMS: NAME and OBJECT are added to simulated groups (#50018).
- KNXDriver: Fix; 59; Additional knx types are suported (#50060).
- apigateway: Add base auth and allow all origins.
- apigateway: Add operating groups to addons.
- apigateway: Update workspace_read addon to enable get discovery endpoint.
- rest-service: Uploaded file can be set to be lowercased.
- dms-proxy: Add implement proxy communication with instanceUuid and or processUuid by calling processManager api (#50444).
- ProcessManager: Add processManagerEndpoint argument for Api-Gateway and Dms-Broker (#50443).
- ProcessManager: Add filterProcessName for template request.
- ProcessManager: Add categories for process templates (#50107).

### Changed

- ProcessManager: Refactored netatmo driver (#49321).

### Fixed

- DMS: Fix type checking for json data (#50442).
- DMS: Fix loading combined alarms and process control functions (#50474).
- DMS: New alarm and changelog list from all protocols (#50632).
- CPP-Modules: Fix UTF8 invalid characters in file path (#50612).
- DeviceDrivers: Update PRG content on bmo update (#45969).
- ProcessManager: Avoid start jobs on process manager terminate (#50388).
- Device-API's: Fix wrong configuration detection (#49098).
- DeviceAPI's: Fix crash on deleted device configuration (#49098).
- OPC_UA_Client_API: Fix crash on single node read (#49098).
- apigateway: Fix restart after server settings change lookup for apigateway uuid (#50802).
- apigateway: Refactor server settings with new models (#50802).
- apigateway: Update cli flags and arguments in process (#50360).
- apigateway: Fix user specific tls key and cert upload (#50196).
- apigateway: Enabling setting port number full range of 16bit (#50095).
- rest-service: Json body is parsed correctly (#50527)


## FRONTEND

### Added

- vue-ng-lib: Add Buttons to Spreadsheet and implemented in Engineering-Detail View (#50817)
- vue-ng-lib: Alarms are only visible according to the OperatingGroups (#48886).
- vue-ng-lib: Add OperatingGroupInfo component (#48886).
- vue-ng-lib: Add serie name property to dms chart component (#50369).
- vue-ng-lib: Implement help and tooltip per input component (#50399).
- vue-ng-lib: Range by minutes of the diagram is stored in local storage (#50075).
- vue-ng-lib: NgSpreadsheet component supports the display of icons (#50354).
- vue-ng-lib: Column can be (in-)visible (#50350).
- vue-ng-lib: Update date and datetime input for parsing numbers and add soft-static linking to computed object. (#50339).
- vue-ng-lib: Add nexttick to ng config form props parsing (#50318).
- vue-ng-lib: NgSpreadsheet component supports custom ContextMenu-entrys (#50197).
- vue-ng-lib: Add support for multiple datatypes per column in NgSpreadjs (#50256)
- vue-ng-lib: New menu added to move a selected object to 1 px distance (#47521).
- vue-ng-lib: a title for object panel dialog can be predefined (#50132).

### Removed

- vue-ng-lib: Remove input min max because we use rules as limit in port settings (#50095).

### Fixed

- vue-ng-lib: Fix alarm count in alarm table (#50931).
- vue-ng-lib: Fix clone object in ng config components (#50209).
- vue-ng-lib: Do not break requesting workspace servers if one is not reachable (#50805).
- vue-ng-lib: Refactor computed dialog default item and compute behaviour (#50537).
- vue-ng-lib: Disable seamless false on link dialogs to keep editing input in other dialogs enabled (#50419).
- vue-ng-lib: Refactor chart component (#50368).
- vue-ng-lib: Set value dialog ic closed after submitting the value (#50175)
- vue-ng-lib: Fix help and tooltip in form input (#50404).
- vue-ng-lib: Fix collect tab widgets variables and do not set prev digit value if undefined (#50324).
- vue-ng-lib: Fix reactivity in NgConfig Forms and display captions by forms as markdown (#50318).
- vue-ng-lib: Fix port limitation and implement set buttons for default ports (#50095).

### Other

- vue-ng-lib: Notify server settings error if exists (#50196).
- vue-ng-lib: Start-time, end-time and interval of the chart objects are stored in local storage (#50075).
- vue-ng-lib: Implement hidden Pages in designer with hidden, permissions und roles (#50104).

## CONFIGURATION

### Added

- rest-data: Disable add multiple singleton processes (#50239).
- rest-data: Implement serie name input in chart widget (#50369).
- rest-data: Implement options amount variable in select widget for dynamic options (#50432).
- rest-data: Add description to suffix input and fix empty date in date widget(#50339).
- rest-data: Add exclude nodes for OPC UA (#49098).
- rest-data: Translations are added. Title of setvalue dialog can be predefined (#50132)

### Fixed

- rest-data: Fix web configuration ad/remove bus (#50338).
- rest-data: Set value dialog if closed after submitting the value (#50175).
- rest-data: Fix computed label in state widget (#50424).
- rest-data: Set property alarm as object if not defined in workspace (#50374).
- rest-data: Set empty object in header-modifier to get valid payload. (#50400).
- rest-data: Fix reactivity in widget attributes (#50318).

### Other

- rest-data: Refactor digits in number widget (#50324).
- rest-data: Update lang for default ports (#50095)


# [v3.1.0] - 2024-07-17 

## BACKEND

### Added

- intelli-service: Add widget names migration.
- intelli-service: Add portal job start.
- intelli-service: Add alarm counter.
- intelli-service: Add annotation time normalization.
- genstx: Add newest library.
- genstx: New model applications and delimiter implementation (#48282).
- genstx: New package server extend server with warning and log emitter (#49964).

### Changed

- intelli-service: Change parentNode to yAxis.
- intelli-service: Change portal api endpoint name.

### Fixed

- api-broker: Api-Broker sparql client is fixed - missed accept header has been added (#49626).
- DMS: Fix short get command (#50078).
- DMS: Fix copy node recursion (#49540).
- Setup: Fix;; uninstall/install of vcredist 2019 (#49124).
- intelli-service: Fix alarm handler.
- Designer: Image Files are structured in rest-db (#49969).
- Designer: Destination folder for project images is fixed (#49954).

### Other

- apigateway: Implement access-token login through auto login.
- apigateway: Always remove allow origin in proxy stack because we handle it in single reverse proxy.
- apigateway: Refactor settings and run server http and https per default.
- mqttdriver: Optimize log if DMS sends errors in set (#49205).

## FRONTEND

### Added

- vue-ng-lib: Add i18n translation to md editor.
- vue-ng-lib: Accepted files extensions are added (#47724).
- bai: Add multi row deletion.

### Changed

- vue-ng-lib: Changed readonly attribute name.
- vue-ng-lib: Prefix for export can be empty (#49478).

### Fixed

- vue-ng-lib: Refactor adds NgButton if only one entry exists.
- vue-ng-lib: Diff and time are added to "TRD DP add" dialog (#48787).
- vue-ng-lib: Add NgDMSAlarmColorTable Component.
- vue-ng-lib: Prepare info prop for components and add css style to markdown (#49316).
- vue-ng-lib: Fix key on select server (#41179).
- vue-ng-lib: Fix inject serviceUuids from parent to childs (#41179).
- vue-ng-lib: Fix of design dms node chart component (#49671).
- vue-ng-lib: Fix of NgDMSNodeChart Component (#49671).
- vue-ng-lib: Fix of NgDMSAlarmInstructions sizes (#49627)
- vue-ng-lib: Fix missing set interpolation in dms chart (#49585).
- vue-ng-lib: Fix missing endpoints in EndpointRepository (#49577).
- vue-ng-lib: Web Component rendering has been fixed.
- vue-ng-lib: Fix rendering Asnyc-Component import in NgUI (#49333).
- vue-ng-lib: Fix update model value in splitter (#49328).
- vue-ng-lib: Fix unsetted data in useForm for NgControls (#49038).
- vue-ng-lib: Fix maximum stack call and optimize key variables (#49038).
- vue-ng-lib: Fix undefined focus emitter.
- vue-ng-lib: Fix copy paste widgets in template panel (#49313).
- Designer: Reinitialisation of the dialog objects is fixed (#49965).
- bai: Fixed config model folder deletion on page deletion if no configModel exists.

### Other

- vue-ng-lib: Implement secure communication between NGs (#41179).
- vue-ng-lib: Remove save config in dms-chart because this is not needed (#49585).
- vue-ng-lib: AlarmInstructions component has been refactored (#47724).
- vue-ng-lib: New component for assignment of the alarms texts is implemented (#47724).
- vue-ng-lib: Debounce splitter update (#49328).
- vue-ng-lib: Emit selected events (#49317).
- vue-ng-lib: Double click emit on group item (#49313).
- vue-ng-lib: Copy paste template panel tabs (#49315).

## CONFIGURATION

### Added

- rest-data: Add applications (#48282).
- rest-data: Add alarm format to alarm page.

### Fixed

- rest-data: Fix chart widget by setting the correct processManagerUuid in chart nodes.
- rest-data: fix wrong labels (#48068).
- rest-data: Fix of change image web component (#47275).
- rest-data: Fix call onInit in mounted hook, call it in onSubscribed callback (#49585).
- rest-data: Fix NgSplitter in modules (#49328).

### Other

- rest-data: Implement secure service communication (#41179).
- rest-data: dms.chart component has been updated (#49671).
- rest-data: Web components are adjusted (#47275).
- rest-data: Optimize dms.chart Web-Component for designer (#49581).
- rest-data: Translations are adjusted (#48787).
- rest-data: Lang for template panel info (#49316).


# [v3.0.1] - 2024-06-10

## General

- Initial stable setup

